case zcore_callid::logon: {
	auto &q = *static_cast<const zcreq_logon *>(q0);
	auto r1 = std::make_unique<zcresp_logon>();
	auto &r = *r1;
	r1->result = zs_logon(q.username, q.password, q.rhost, q.flags, &r.hsession);
	r0 = std::move(r1);
	break;
}
case zcore_callid::uinfo: {
	auto &q = *static_cast<const zcreq_uinfo *>(q0);
	auto r1 = std::make_unique<zcresp_uinfo>();
	auto &r = *r1;
	r1->result = zs_uinfo(q.username, &r.entryid, &r.pdisplay_name, &r.px500dn, &r.privilege_bits);
	r0 = std::move(r1);
	break;
}
case zcore_callid::unloadobject: {
	auto &q = *static_cast<const zcreq_unloadobject *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_unloadobject>();
	r1->result = zs_unloadobject(q.hsession, q.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openentry: {
	auto &q = *static_cast<const zcreq_openentry *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openentry>();
	auto &r = *r1;
	r1->result = zs_openentry(q.hsession, q.entryid, q.flags, &r.mapi_type, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openstoreentry: {
	auto &q = *static_cast<const zcreq_openstoreentry *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openstoreentry>();
	auto &r = *r1;
	r1->result = zs_openstoreentry(q.hsession, q.hobject, q.entryid, q.flags, &r.mapi_type, &r.hxobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openabentry: {
	auto &q = *static_cast<const zcreq_openabentry *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openabentry>();
	auto &r = *r1;
	r1->result = zs_openabentry(q.hsession, q.entryid, &r.mapi_type, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::resolvename: {
	auto &q = *static_cast<const zcreq_resolvename *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_resolvename>();
	auto &r = *r1;
	r1->result = zs_resolvename(q.hsession, q.pcond_set, &r.result_set);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getpermissions: {
	auto &q = *static_cast<const zcreq_getpermissions *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getpermissions>();
	auto &r = *r1;
	r1->result = zs_getpermissions(q.hsession, q.hobject, &r.perm_set);
	r0 = std::move(r1);
	break;
}
case zcore_callid::modifypermissions: {
	auto &q = *static_cast<const zcreq_modifypermissions *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_modifypermissions>();
	r1->result = zs_modifypermissions(q.hsession, q.hfolder, q.pset);
	r0 = std::move(r1);
	break;
}
case zcore_callid::modifyrules: {
	auto &q = *static_cast<const zcreq_modifyrules *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_modifyrules>();
	r1->result = zs_modifyrules(q.hsession, q.hfolder, q.flags, q.plist);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getabgal: {
	auto &q = *static_cast<const zcreq_getabgal *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getabgal>();
	auto &r = *r1;
	r1->result = zs_getabgal(q.hsession, &r.entryid);
	r0 = std::move(r1);
	break;
}
case zcore_callid::loadstoretable: {
	auto &q = *static_cast<const zcreq_loadstoretable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_loadstoretable>();
	auto &r = *r1;
	r1->result = zs_loadstoretable(q.hsession, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openstore: {
	auto &q = *static_cast<const zcreq_openstore *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openstore>();
	auto &r = *r1;
	r1->result = zs_openstore(q.hsession, q.entryid, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openprofilesec: {
	auto &q = *static_cast<const zcreq_openprofilesec *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openprofilesec>();
	auto &r = *r1;
	r1->result = zs_openprofilesec(q.hsession, q.puid, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::loadhierarchytable: {
	auto &q = *static_cast<const zcreq_loadhierarchytable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_loadhierarchytable>();
	auto &r = *r1;
	r1->result = zs_loadhierarchytable(q.hsession, q.hfolder, q.flags, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::loadcontenttable: {
	auto &q = *static_cast<const zcreq_loadcontenttable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_loadcontenttable>();
	auto &r = *r1;
	r1->result = zs_loadcontenttable(q.hsession, q.hfolder, q.flags, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::loadrecipienttable: {
	auto &q = *static_cast<const zcreq_loadrecipienttable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_loadrecipienttable>();
	auto &r = *r1;
	r1->result = zs_loadrecipienttable(q.hsession, q.hmessage, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::loadruletable: {
	auto &q = *static_cast<const zcreq_loadruletable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_loadruletable>();
	auto &r = *r1;
	r1->result = zs_loadruletable(q.hsession, q.hfolder, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::createmessage: {
	auto &q = *static_cast<const zcreq_createmessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_createmessage>();
	auto &r = *r1;
	r1->result = zs_createmessage(q.hsession, q.hfolder, q.flags, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::deletemessages: {
	auto &q = *static_cast<const zcreq_deletemessages *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_deletemessages>();
	r1->result = zs_deletemessages(q.hsession, q.hfolder, q.pentryids, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::copymessages: {
	auto &q = *static_cast<const zcreq_copymessages *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_copymessages>();
	r1->result = zs_copymessages(q.hsession, q.hsrcfolder, q.hdstfolder, q.pentryids, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::setreadflags: {
	auto &q = *static_cast<const zcreq_setreadflags *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_setreadflags>();
	r1->result = zs_setreadflags(q.hsession, q.hfolder, q.pentryids, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::createfolder: {
	auto &q = *static_cast<const zcreq_createfolder *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_createfolder>();
	auto &r = *r1;
	r1->result = zs_createfolder(q.hsession, q.hparent_folder, q.folder_type, q.folder_name, q.folder_comment, q.flags, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::deletefolder: {
	auto &q = *static_cast<const zcreq_deletefolder *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_deletefolder>();
	r1->result = zs_deletefolder(q.hsession, q.hparent_folder, q.entryid, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::emptyfolder: {
	auto &q = *static_cast<const zcreq_emptyfolder *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_emptyfolder>();
	r1->result = zs_emptyfolder(q.hsession, q.hfolder, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::copyfolder: {
	auto &q = *static_cast<const zcreq_copyfolder *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_copyfolder>();
	r1->result = zs_copyfolder(q.hsession, q.hsrc_folder, q.entryid, q.hdst_folder, q.new_name, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getstoreentryid: {
	auto &q = *static_cast<const zcreq_getstoreentryid *>(q0);
	auto r1 = std::make_unique<zcresp_getstoreentryid>();
	auto &r = *r1;
	r1->result = zs_getstoreentryid(q.mailbox_dn, &r.entryid);
	r0 = std::move(r1);
	break;
}
case zcore_callid::entryidfromsourcekey: {
	auto &q = *static_cast<const zcreq_entryidfromsourcekey *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_entryidfromsourcekey>();
	auto &r = *r1;
	r1->result = zs_entryidfromsourcekey(q.hsession, q.hstore, q.folder_key, q.pmessage_key, &r.entryid);
	r0 = std::move(r1);
	break;
}
case zcore_callid::storeadvise: {
	auto &q = *static_cast<const zcreq_storeadvise *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_storeadvise>();
	auto &r = *r1;
	r1->result = zs_storeadvise(q.hsession, q.hstore, q.pentryid, q.event_mask, &r.sub_id);
	r0 = std::move(r1);
	break;
}
case zcore_callid::unadvise: {
	auto &q = *static_cast<const zcreq_unadvise *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_unadvise>();
	r1->result = zs_unadvise(q.hsession, q.hstore, q.sub_id);
	r0 = std::move(r1);
	break;
}
case zcore_callid::notifdequeue: {
	auto &q = *static_cast<const zcreq_notifdequeue *>(q0);
	auto r1 = std::make_unique<zcresp_notifdequeue>();
	auto &r = *r1;
	r1->result = zs_notifdequeue(q.psink, q.timeval, &r.notifications);
	r0 = std::move(r1);
	break;
}
case zcore_callid::queryrows: {
	auto &q = *static_cast<const zcreq_queryrows *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_queryrows>();
	auto &r = *r1;
	r1->result = zs_queryrows(q.hsession, q.htable, q.start, q.count, q.prestriction, q.pproptags, &r.rowset);
	r0 = std::move(r1);
	break;
}
case zcore_callid::setcolumns: {
	auto &q = *static_cast<const zcreq_setcolumns *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_setcolumns>();
	r1->result = zs_setcolumns(q.hsession, q.htable, q.pproptags, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::seekrow: {
	auto &q = *static_cast<const zcreq_seekrow *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_seekrow>();
	auto &r = *r1;
	r1->result = zs_seekrow(q.hsession, q.htable, q.bookmark, q.seek_rows, &r.sought_rows);
	r0 = std::move(r1);
	break;
}
case zcore_callid::sorttable: {
	auto &q = *static_cast<const zcreq_sorttable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_sorttable>();
	r1->result = zs_sorttable(q.hsession, q.htable, q.psortset);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getrowcount: {
	auto &q = *static_cast<const zcreq_getrowcount *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getrowcount>();
	auto &r = *r1;
	r1->result = zs_getrowcount(q.hsession, q.htable, &r.count);
	r0 = std::move(r1);
	break;
}
case zcore_callid::restricttable: {
	auto &q = *static_cast<const zcreq_restricttable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_restricttable>();
	r1->result = zs_restricttable(q.hsession, q.htable, q.prestriction, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::findrow: {
	auto &q = *static_cast<const zcreq_findrow *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_findrow>();
	auto &r = *r1;
	r1->result = zs_findrow(q.hsession, q.htable, q.bookmark, q.prestriction, q.flags, &r.row_idx);
	r0 = std::move(r1);
	break;
}
case zcore_callid::createbookmark: {
	auto &q = *static_cast<const zcreq_createbookmark *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_createbookmark>();
	auto &r = *r1;
	r1->result = zs_createbookmark(q.hsession, q.htable, &r.bookmark);
	r0 = std::move(r1);
	break;
}
case zcore_callid::freebookmark: {
	auto &q = *static_cast<const zcreq_freebookmark *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_freebookmark>();
	r1->result = zs_freebookmark(q.hsession, q.htable, q.bookmark);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getreceivefolder: {
	auto &q = *static_cast<const zcreq_getreceivefolder *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getreceivefolder>();
	auto &r = *r1;
	r1->result = zs_getreceivefolder(q.hsession, q.hstore, q.pstrclass, &r.entryid);
	r0 = std::move(r1);
	break;
}
case zcore_callid::modifyrecipients: {
	auto &q = *static_cast<const zcreq_modifyrecipients *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_modifyrecipients>();
	r1->result = zs_modifyrecipients(q.hsession, q.hmessage, q.flags, q.prcpt_list);
	r0 = std::move(r1);
	break;
}
case zcore_callid::submitmessage: {
	auto &q = *static_cast<const zcreq_submitmessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_submitmessage>();
	r1->result = zs_submitmessage(q.hsession, q.hmessage);
	r0 = std::move(r1);
	break;
}
case zcore_callid::loadattachmenttable: {
	auto &q = *static_cast<const zcreq_loadattachmenttable *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_loadattachmenttable>();
	auto &r = *r1;
	r1->result = zs_loadattachmenttable(q.hsession, q.hmessage, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openattachment: {
	auto &q = *static_cast<const zcreq_openattachment *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openattachment>();
	auto &r = *r1;
	r1->result = zs_openattachment(q.hsession, q.hmessage, q.attach_id, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::createattachment: {
	auto &q = *static_cast<const zcreq_createattachment *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_createattachment>();
	auto &r = *r1;
	r1->result = zs_createattachment(q.hsession, q.hmessage, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::deleteattachment: {
	auto &q = *static_cast<const zcreq_deleteattachment *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_deleteattachment>();
	r1->result = zs_deleteattachment(q.hsession, q.hmessage, q.attach_id);
	r0 = std::move(r1);
	break;
}
case zcore_callid::setpropvals: {
	auto &q = *static_cast<const zcreq_setpropvals *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_setpropvals>();
	r1->result = zs_setpropvals(q.hsession, q.hobject, q.ppropvals);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getpropvals: {
	auto &q = *static_cast<const zcreq_getpropvals *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getpropvals>();
	auto &r = *r1;
	r1->result = zs_getpropvals(q.hsession, q.hobject, q.pproptags, &r.propvals);
	r0 = std::move(r1);
	break;
}
case zcore_callid::deletepropvals: {
	auto &q = *static_cast<const zcreq_deletepropvals *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_deletepropvals>();
	r1->result = zs_deletepropvals(q.hsession, q.hobject, q.pproptags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::setmessagereadflag: {
	auto &q = *static_cast<const zcreq_setmessagereadflag *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_setmessagereadflag>();
	r1->result = zs_setmessagereadflag(q.hsession, q.hmessage, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::openembedded: {
	auto &q = *static_cast<const zcreq_openembedded *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_openembedded>();
	auto &r = *r1;
	r1->result = zs_openembedded(q.hsession, q.hattachment, q.flags, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getnamedpropids: {
	auto &q = *static_cast<const zcreq_getnamedpropids *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getnamedpropids>();
	auto &r = *r1;
	r1->result = zs_getnamedpropids(q.hsession, q.hstore, q.ppropnames, &r.propids);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getpropnames: {
	auto &q = *static_cast<const zcreq_getpropnames *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getpropnames>();
	auto &r = *r1;
	r1->result = zs_getpropnames(q.hsession, q.hstore, q.ppropids, &r.propnames);
	r0 = std::move(r1);
	break;
}
case zcore_callid::copyto: {
	auto &q = *static_cast<const zcreq_copyto *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_copyto>();
	r1->result = zs_copyto(q.hsession, q.hsrcobject, q.pexclude_proptags, q.hdstobject, q.flags);
	r0 = std::move(r1);
	break;
}
case zcore_callid::savechanges: {
	auto &q = *static_cast<const zcreq_savechanges *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_savechanges>();
	r1->result = zs_savechanges(q.hsession, q.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::hierarchysync: {
	auto &q = *static_cast<const zcreq_hierarchysync *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_hierarchysync>();
	auto &r = *r1;
	r1->result = zs_hierarchysync(q.hsession, q.hfolder, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::contentsync: {
	auto &q = *static_cast<const zcreq_contentsync *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_contentsync>();
	auto &r = *r1;
	r1->result = zs_contentsync(q.hsession, q.hfolder, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::configsync: {
	auto &q = *static_cast<const zcreq_configsync *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_configsync>();
	auto &r = *r1;
	r1->result = zs_configsync(q.hsession, q.hctx, q.flags, q.pstate, q.prestriction, &r.b_changed, &r.count);
	r0 = std::move(r1);
	break;
}
case zcore_callid::statesync: {
	auto &q = *static_cast<const zcreq_statesync *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_statesync>();
	auto &r = *r1;
	r1->result = zs_statesync(q.hsession, q.hctx, &r.state);
	r0 = std::move(r1);
	break;
}
case zcore_callid::syncmessagechange: {
	auto &q = *static_cast<const zcreq_syncmessagechange *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_syncmessagechange>();
	auto &r = *r1;
	r1->result = zs_syncmessagechange(q.hsession, q.hctx, &r.b_new, &r.proplist);
	r0 = std::move(r1);
	break;
}
case zcore_callid::syncfolderchange: {
	auto &q = *static_cast<const zcreq_syncfolderchange *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_syncfolderchange>();
	auto &r = *r1;
	r1->result = zs_syncfolderchange(q.hsession, q.hctx, &r.proplist);
	r0 = std::move(r1);
	break;
}
case zcore_callid::syncreadstatechanges: {
	auto &q = *static_cast<const zcreq_syncreadstatechanges *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_syncreadstatechanges>();
	auto &r = *r1;
	r1->result = zs_syncreadstatechanges(q.hsession, q.hctx, &r.states);
	r0 = std::move(r1);
	break;
}
case zcore_callid::syncdeletions: {
	auto &q = *static_cast<const zcreq_syncdeletions *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_syncdeletions>();
	auto &r = *r1;
	r1->result = zs_syncdeletions(q.hsession, q.hctx, q.flags, &r.bins);
	r0 = std::move(r1);
	break;
}
case zcore_callid::hierarchyimport: {
	auto &q = *static_cast<const zcreq_hierarchyimport *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_hierarchyimport>();
	auto &r = *r1;
	r1->result = zs_hierarchyimport(q.hsession, q.hfolder, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::contentimport: {
	auto &q = *static_cast<const zcreq_contentimport *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_contentimport>();
	auto &r = *r1;
	r1->result = zs_contentimport(q.hsession, q.hfolder, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::configimport: {
	auto &q = *static_cast<const zcreq_configimport *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_configimport>();
	r1->result = zs_configimport(q.hsession, q.hctx, q.sync_type, q.pstate);
	r0 = std::move(r1);
	break;
}
case zcore_callid::stateimport: {
	auto &q = *static_cast<const zcreq_stateimport *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_stateimport>();
	auto &r = *r1;
	r1->result = zs_stateimport(q.hsession, q.hctx, &r.state);
	r0 = std::move(r1);
	break;
}
case zcore_callid::importmessage: {
	auto &q = *static_cast<const zcreq_importmessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_importmessage>();
	auto &r = *r1;
	r1->result = zs_importmessage(q.hsession, q.hctx, q.flags, q.pproplist, &r.hobject);
	r0 = std::move(r1);
	break;
}
case zcore_callid::importfolder: {
	auto &q = *static_cast<const zcreq_importfolder *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_importfolder>();
	r1->result = zs_importfolder(q.hsession, q.hctx, q.pproplist);
	r0 = std::move(r1);
	break;
}
case zcore_callid::importdeletion: {
	auto &q = *static_cast<const zcreq_importdeletion *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_importdeletion>();
	r1->result = zs_importdeletion(q.hsession, q.hctx, q.flags, q.pbins);
	r0 = std::move(r1);
	break;
}
case zcore_callid::importreadstates: {
	auto &q = *static_cast<const zcreq_importreadstates *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_importreadstates>();
	r1->result = zs_importreadstates(q.hsession, q.hctx, q.pstates);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getsearchcriteria: {
	auto &q = *static_cast<const zcreq_getsearchcriteria *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getsearchcriteria>();
	auto &r = *r1;
	r1->result = zs_getsearchcriteria(q.hsession, q.hfolder, &r.folder_array, &r.prestriction, &r.search_stat);
	r0 = std::move(r1);
	break;
}
case zcore_callid::setsearchcriteria: {
	auto &q = *static_cast<const zcreq_setsearchcriteria *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_setsearchcriteria>();
	r1->result = zs_setsearchcriteria(q.hsession, q.hfolder, q.flags, q.pfolder_array, q.prestriction);
	r0 = std::move(r1);
	break;
}
case zcore_callid::messagetorfc822: {
	auto &q = *static_cast<const zcreq_messagetorfc822 *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_messagetorfc822>();
	auto &r = *r1;
	r1->result = zs_messagetorfc822(q.hsession, q.hmessage, &r.eml_bin);
	r0 = std::move(r1);
	break;
}
case zcore_callid::rfc822tomessage: {
	auto &q = *static_cast<const zcreq_rfc822tomessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_rfc822tomessage>();
	r1->result = zs_rfc822tomessage(q.hsession, q.hmessage, q.mxf_flags, q.peml_bin);
	r0 = std::move(r1);
	break;
}
case zcore_callid::messagetoical: {
	auto &q = *static_cast<const zcreq_messagetoical *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_messagetoical>();
	auto &r = *r1;
	r1->result = zs_messagetoical(q.hsession, q.hmessage, &r.ical_bin);
	r0 = std::move(r1);
	break;
}
case zcore_callid::icaltomessage: {
	auto &q = *static_cast<const zcreq_icaltomessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_icaltomessage>();
	r1->result = zs_icaltomessage(q.hsession, q.hmessage, q.pical_bin);
	r0 = std::move(r1);
	break;
}
case zcore_callid::messagetovcf: {
	auto &q = *static_cast<const zcreq_messagetovcf *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_messagetovcf>();
	auto &r = *r1;
	r1->result = zs_messagetovcf(q.hsession, q.hmessage, &r.vcf_bin);
	r0 = std::move(r1);
	break;
}
case zcore_callid::vcftomessage: {
	auto &q = *static_cast<const zcreq_vcftomessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_vcftomessage>();
	r1->result = zs_vcftomessage(q.hsession, q.hmessage, q.pvcf_bin);
	r0 = std::move(r1);
	break;
}
case zcore_callid::setpasswd: {
	auto &q = *static_cast<const zcreq_setpasswd *>(q0);
	auto r1 = std::make_unique<zcresp_setpasswd>();
	r1->result = zs_setpasswd(q.username, q.passwd, q.new_passwd);
	r0 = std::move(r1);
	break;
}
case zcore_callid::linkmessage: {
	auto &q = *static_cast<const zcreq_linkmessage *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_linkmessage>();
	r1->result = zs_linkmessage(q.hsession, q.search_entryid, q.message_entryid);
	r0 = std::move(r1);
	break;
}
case zcore_callid::checksession: {
	auto &q = *static_cast<const zcreq_checksession *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_checksession>();
	r1->result = zs_checksession(q.hsession);
	r0 = std::move(r1);
	break;
}
case zcore_callid::imtomessage2: {
	auto &q = *static_cast<const zcreq_imtomessage2 *>(q0);
	auto r1 = std::make_unique<zcresp_imtomessage2>();
	auto &r = *r1;
	r1->result = zs_imtomessage2(q.session, q.folder, q.data_type, q.im_data, &r.msg_handles);
	r0 = std::move(r1);
	break;
}
case zcore_callid::essdn_to_username: {
	auto &q = *static_cast<const zcreq_essdn_to_username *>(q0);
	auto r1 = std::make_unique<zcresp_essdn_to_username>();
	auto &r = *r1;
	r1->result = zs_essdn_to_username(q.essdn, &r.username);
	r0 = std::move(r1);
	break;
}
case zcore_callid::logon_token: {
	auto &q = *static_cast<const zcreq_logon_token *>(q0);
	auto r1 = std::make_unique<zcresp_logon_token>();
	auto &r = *r1;
	r1->result = zs_logon_token(q.token, q.rhost, &r.hsession);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getuserfreebusy: {
	auto &q = *static_cast<const zcreq_getuserfreebusy *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getuserfreebusy>();
	auto &r = *r1;
	r1->result = zs_getuserfreebusy(q.hsession, q.entryid, q.starttime, q.endtime, &r.fb_events);
	r0 = std::move(r1);
	break;
}
case zcore_callid::getuserfreebusyical: {
	auto &q = *static_cast<const zcreq_getuserfreebusyical *>(q0);
	dbg_hsession = q.hsession;
	auto r1 = std::make_unique<zcresp_getuserfreebusyical>();
	auto &r = *r1;
	r1->result = zs_getuserfreebusyical(q.hsession, q.entryid, q.starttime, q.endtime, &r.ical_bin);
	r0 = std::move(r1);
	break;
}
